diff --git a/drivers/edac/edac_device.c b/drivers/edac/edac_device.c
index 78ac44103acc..4f735c625c36 100644
--- a/drivers/edac/edac_device.c
+++ b/drivers/edac/edac_device.c
@@ -555,95 +555,6 @@ static inline int edac_device_get_panic_on_ue(struct edac_device_ctl_info
 	return edac_dev->panic_on_ue;
 }
 
-void edac_device_handle_ce(struct edac_device_ctl_info *edac_dev,
-			int inst_nr, int block_nr, const char *msg)
-{
-	struct edac_device_instance *instance;
-	struct edac_device_block *block = NULL;
-
-	if ((inst_nr >= edac_dev->nr_instances) || (inst_nr < 0)) {
-		edac_device_printk(edac_dev, KERN_ERR,
-				"INTERNAL ERROR: 'instance' out of range "
-				"(%d >= %d)\n", inst_nr,
-				edac_dev->nr_instances);
-		return;
-	}
-
-	instance = edac_dev->instances + inst_nr;
-
-	if ((block_nr >= instance->nr_blocks) || (block_nr < 0)) {
-		edac_device_printk(edac_dev, KERN_ERR,
-				"INTERNAL ERROR: instance %d 'block' "
-				"out of range (%d >= %d)\n",
-				inst_nr, block_nr,
-				instance->nr_blocks);
-		return;
-	}
-
-	if (instance->nr_blocks > 0) {
-		block = instance->blocks + block_nr;
-		block->counters.ce_count++;
-	}
-
-	/* Propagate the count up the 'totals' tree */
-	instance->counters.ce_count++;
-	edac_dev->counters.ce_count++;
-
-	if (edac_device_get_log_ce(edac_dev))
-		edac_device_printk(edac_dev, KERN_WARNING,
-				"CE: %s instance: %s block: %s '%s'\n",
-				edac_dev->ctl_name, instance->name,
-				block ? block->name : "N/A", msg);
-}
-EXPORT_SYMBOL_GPL(edac_device_handle_ce);
-
-void edac_device_handle_ue(struct edac_device_ctl_info *edac_dev,
-			int inst_nr, int block_nr, const char *msg)
-{
-	struct edac_device_instance *instance;
-	struct edac_device_block *block = NULL;
-
-	if ((inst_nr >= edac_dev->nr_instances) || (inst_nr < 0)) {
-		edac_device_printk(edac_dev, KERN_ERR,
-				"INTERNAL ERROR: 'instance' out of range "
-				"(%d >= %d)\n", inst_nr,
-				edac_dev->nr_instances);
-		return;
-	}
-
-	instance = edac_dev->instances + inst_nr;
-
-	if ((block_nr >= instance->nr_blocks) || (block_nr < 0)) {
-		edac_device_printk(edac_dev, KERN_ERR,
-				"INTERNAL ERROR: instance %d 'block' "
-				"out of range (%d >= %d)\n",
-				inst_nr, block_nr,
-				instance->nr_blocks);
-		return;
-	}
-
-	if (instance->nr_blocks > 0) {
-		block = instance->blocks + block_nr;
-		block->counters.ue_count++;
-	}
-
-	/* Propagate the count up the 'totals' tree */
-	instance->counters.ue_count++;
-	edac_dev->counters.ue_count++;
-
-	if (edac_device_get_log_ue(edac_dev))
-		edac_device_printk(edac_dev, KERN_EMERG,
-				"UE: %s instance: %s block: %s '%s'\n",
-				edac_dev->ctl_name, instance->name,
-				block ? block->name : "N/A", msg);
-
-	if (edac_device_get_panic_on_ue(edac_dev))
-		panic("EDAC %s: UE instance: %s block %s '%s'\n",
-			edac_dev->ctl_name, instance->name,
-			block ? block->name : "N/A", msg);
-}
-EXPORT_SYMBOL_GPL(edac_device_handle_ue);
-
 void __edac_device_handle_ce(struct edac_device_ctl_info *edac_dev,
 			     unsigned int count, int inst_nr, int block_nr,
 			     const char *msg)
diff --git a/drivers/edac/edac_device.h b/drivers/edac/edac_device.h
index 30dc5f5979c8..796ea134a691 100644
--- a/drivers/edac/edac_device.h
+++ b/drivers/edac/edac_device.h
@@ -285,29 +285,6 @@ extern int edac_device_add_device(struct edac_device_ctl_info *edac_dev);
  */
 extern struct edac_device_ctl_info *edac_device_del_device(struct device *dev);
 
-/**
- * edac_device_handle_ue():
- *	perform a common output and handling of an 'edac_dev' UE event
- *
- * @edac_dev: pointer to struct &edac_device_ctl_info
- * @inst_nr: number of the instance where the UE error happened
- * @block_nr: number of the block where the UE error happened
- * @msg: message to be printed
- */
-extern void edac_device_handle_ue(struct edac_device_ctl_info *edac_dev,
-				int inst_nr, int block_nr, const char *msg);
-/**
- * edac_device_handle_ce():
- *	perform a common output and handling of an 'edac_dev' CE event
- *
- * @edac_dev: pointer to struct &edac_device_ctl_info
- * @inst_nr: number of the instance where the CE error happened
- * @block_nr: number of the block where the CE error happened
- * @msg: message to be printed
- */
-extern void edac_device_handle_ce(struct edac_device_ctl_info *edac_dev,
-				int inst_nr, int block_nr, const char *msg);
-
 /**
  * edac_device_alloc_index: Allocate a unique device index number
  *
@@ -357,4 +334,18 @@ static inline void edac_device_handle_ue_count(struct edac_device_ctl_info *edac
 {
 	__edac_device_handle_ue(edac_dev, count, inst_nr, block_nr, msg);
 }
+
+static inline void edac_device_handle_ce(struct edac_device_ctl_info *edac_dev,
+					 int inst_nr, int block_nr,
+					 const char *msg)
+{
+	__edac_device_handle_ce(edac_dev, 1, inst_nr, block_nr, msg);
+}
+
+static inline void edac_device_handle_ue(struct edac_device_ctl_info *edac_dev,
+					 int inst_nr, int block_nr,
+					 const char *msg)
+{
+	__edac_device_handle_ue(edac_dev, 1, inst_nr, block_nr, msg);
+}
 #endif